diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/he/he-frame-exchange-manager.cc ns-3.42/src/wifi/model/he/he-frame-exchange-manager.cc
--- ns-3.41/src/wifi/model/he/he-frame-exchange-manager.cc	2024-02-09 14:44:08.585795000 -0800
+++ ns-3.42/src/wifi/model/he/he-frame-exchange-manager.cc	2024-05-29 15:29:47.200073700 -0700
@@ -37,7 +37,7 @@
 #include <functional>
 
 #undef NS_LOG_APPEND_CONTEXT
-#define NS_LOG_APPEND_CONTEXT std::clog << "[link=" << +m_linkId << "][mac=" << m_self << "] "
+#define NS_LOG_APPEND_CONTEXT WIFI_FEM_NS_LOG_APPEND_CONTEXT
 
 namespace ns3
 {
@@ -88,7 +88,7 @@
 HeFrameExchangeManager::Reset()
 {
     NS_LOG_FUNCTION(this);
-    if (m_intraBssNavResetEvent.IsRunning())
+    if (m_intraBssNavResetEvent.IsPending())
     {
         m_intraBssNavResetEvent.Cancel();
     }
@@ -212,7 +212,7 @@
     // can reuse this value.
     NS_ASSERT(m_txParams.m_acknowledgment);
 
-    if (m_txParams.m_acknowledgment->acknowledgmentTime == Time::Min())
+    if (!m_txParams.m_acknowledgment->acknowledgmentTime.has_value())
     {
         CalculateAcknowledgmentTime(m_txParams.m_acknowledgment.get());
     }
@@ -233,7 +233,7 @@
                                          << ") incompatible with BSRP Trigger Frame");
         // Add a SIFS and the TB PPDU duration to the acknowledgment time of the Trigger Frame
         auto txVector = trigger.GetHeTbTxVector(trigger.begin()->GetAid12());
-        m_txParams.m_acknowledgment->acknowledgmentTime +=
+        *m_txParams.m_acknowledgment->acknowledgmentTime +=
             m_phy->GetSifs() + HePhy::ConvertLSigLengthToHeTbPpduDuration(trigger.GetUlLength(),
                                                                           txVector,
                                                                           m_phy->GetPhyBand());
@@ -360,12 +360,13 @@
 
     auto mpdu = Create<WifiMpdu>(payload, hdr);
 
-    NS_ASSERT(txParams.m_txDuration != Time::Min());
+    NS_ASSERT(txParams.m_txDuration.has_value());
+    NS_ASSERT(txParams.m_acknowledgment->acknowledgmentTime.has_value());
     mpdu->GetHeader().SetDuration(
         GetMuRtsDurationId(mpdu->GetSize(),
                            protection->muRtsTxVector,
-                           txParams.m_txDuration,
-                           txParams.m_acknowledgment->acknowledgmentTime));
+                           *txParams.m_txDuration,
+                           *txParams.m_acknowledgment->acknowledgmentTime));
 
     // Get the TXVECTOR used by one station to send the CTS response. This is used
     // to compute the preamble duration, so it does not matter which station we choose
@@ -536,8 +537,7 @@
         // schedule the transmission of required BlockAckReq frames
         for (const auto& psdu : m_psduMap)
         {
-            if (acknowledgment->stationsSendBlockAckReqTo.find(psdu.second->GetAddr1()) !=
-                acknowledgment->stationsSendBlockAckReqTo.end())
+            if (acknowledgment->stationsSendBlockAckReqTo.contains(psdu.second->GetAddr1()))
             {
                 // the receiver of this PSDU will receive a BlockAckReq
                 std::set<uint8_t> tids = psdu.second->GetTids();
@@ -625,7 +625,7 @@
                                                          acknowledgment->muBarTxVector,
                                                          m_phy->GetPhyBand());
             // update acknowledgmentTime to correctly set the Duration/ID
-            acknowledgment->acknowledgmentTime -= (m_phy->GetSifs() + txDuration);
+            *acknowledgment->acknowledgmentTime -= (m_phy->GetSifs() + txDuration);
             m_triggerFrame->GetHeader().SetDuration(GetPsduDurationId(txDuration, m_txParams));
 
             responseTxVector =
@@ -1233,13 +1233,14 @@
         txParams.m_acknowledgment->method == WifiAcknowledgment::DL_MU_AGGREGATE_TF)
     {
         // we need to account for the size of the aggregated MU-BAR Trigger Frame
-        auto acknowledgment = static_cast<WifiDlMuAggregateTf*>(txParams.m_acknowledgment.get());
-
-        const auto& info = acknowledgment->stationsReplyingWithBlockAck.find(receiver);
-        NS_ASSERT(info != acknowledgment->stationsReplyingWithBlockAck.end());
-
-        ppduPayloadSize =
-            MpduAggregator::GetSizeIfAggregated(info->second.muBarSize, ppduPayloadSize);
+        auto psduInfo = txParams.GetPsduInfo(receiver);
+        NS_ASSERT_MSG(psduInfo, "No information for " << receiver << " in TX params");
+        NS_ASSERT_MSG(!psduInfo->seqNumbers.empty(), "No sequence number for " << receiver);
+        const auto tid = psduInfo->seqNumbers.cbegin()->first;
+
+        ppduPayloadSize = MpduAggregator::GetSizeIfAggregated(
+            GetMuBarSize({m_mac->GetBarTypeAsOriginator(receiver, tid)}),
+            ppduPayloadSize);
     }
 
     uint16_t staId = (txParams.m_txVector.IsDlMu() ? m_apMac->GetAssociationId(receiver, m_linkId)
@@ -1249,7 +1250,7 @@
                                                    m_phy->GetPhyBand(),
                                                    staId);
 
-    return std::max(psduDuration, txParams.m_txDuration);
+    return txParams.m_txDuration ? std::max(psduDuration, *txParams.m_txDuration) : psduDuration;
 }
 
 void
@@ -1272,7 +1273,7 @@
 
         TransmissionFailed();
     }
-    else if (!m_multiStaBaEvent.IsRunning())
+    else if (!m_multiStaBaEvent.IsPending())
     {
         m_edca->ResetCw(m_linkId);
         TransmissionSucceeded();
@@ -1829,8 +1830,7 @@
         return;
     }
 
-    WifiMacHeader header;
-    header.SetType(WIFI_MAC_QOSDATA_NULL);
+    WifiMacHeader header(WIFI_MAC_QOSDATA_NULL);
     header.SetAddr1(hdr.GetAddr2());
     header.SetAddr2(m_self);
     header.SetAddr3(hdr.GetAddr2());
@@ -1852,36 +1852,38 @@
                                                                    m_phy->GetPhyBand());
     header.SetDuration(hdr.GetDuration() - m_phy->GetSifs() - ppduDuration);
 
-    Ptr<WifiMpdu> mpdu;
     std::vector<Ptr<WifiMpdu>> mpduList;
-    uint8_t tid = 0;
-    header.SetQosTid(tid);
 
-    while (tid < 8 &&
-           IsWithinSizeAndTimeLimits(
-               txParams.GetSizeIfAddMpdu(mpdu = Create<WifiMpdu>(Create<Packet>(), header)),
-               hdr.GetAddr2(),
-               txParams,
-               ppduDuration))
+    for (uint8_t tid = 0; tid < 8; ++tid)
     {
         if (!m_mac->GetBaAgreementEstablishedAsOriginator(hdr.GetAddr2(), tid))
         {
             NS_LOG_DEBUG("Skipping tid=" << +tid << " because no agreement established");
-            header.SetQosTid(++tid);
             continue;
         }
 
-        NS_LOG_DEBUG("Aggregating a QoS Null frame with tid=" << +tid);
-        // We could call TryAddMpdu instead of IsWithinSizeAndTimeLimits above in order to
+        // We could call TryAddMpdu instead of IsWithinSizeAndTimeLimits below in order to
         // get the TX parameters updated automatically. However, aggregating the QoS Null
         // frames might fail because MPDU aggregation is disabled by default for VO
         // and BK. Therefore, we skip the check on max A-MPDU size and only update the
         // TX parameters below.
-        txParams.m_acknowledgment = GetAckManager()->TryAddMpdu(mpdu, txParams);
+        header.SetQosTid(tid);
+        auto mpdu = Create<WifiMpdu>(Create<Packet>(), header);
         txParams.AddMpdu(mpdu);
-        UpdateTxDuration(mpdu->GetHeader().GetAddr1(), txParams);
+        UpdateTxDuration(header.GetAddr1(), txParams);
+
+        if (!IsWithinSizeAndTimeLimits(txParams.GetSize(header.GetAddr1()),
+                                       hdr.GetAddr2(),
+                                       txParams,
+                                       ppduDuration))
+        {
+            txParams.UndoAddMpdu();
+            break;
+        }
+
+        NS_LOG_DEBUG("Aggregating a QoS Null frame with tid=" << +tid);
+        txParams.m_acknowledgment = GetAckManager()->TryAddMpdu(mpdu, txParams);
         mpduList.push_back(mpdu);
-        header.SetQosTid(++tid);
     }
 
     if (mpduList.empty())
@@ -2097,19 +2099,20 @@
     m_channelAccessManager->NotifyNavResetNow(basicNav);
 }
 
-void
-HeFrameExchangeManager::SetTxopHolder(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector)
+std::optional<Mac48Address>
+HeFrameExchangeManager::FindTxopHolder(const WifiMacHeader& hdr, const WifiTxVector& txVector)
 {
-    NS_LOG_FUNCTION(this << psdu << txVector);
+    NS_LOG_FUNCTION(this << hdr << txVector);
 
-    if (psdu->GetHeader(0).IsTrigger() && psdu->GetAddr2() == m_bssid)
+    if (hdr.IsTrigger() && hdr.GetAddr2() == m_bssid)
     {
-        m_txopHolder = m_bssid;
+        return m_bssid;
     }
-    else if (!txVector.IsUlMu()) // the sender of a TB PPDU is not the TXOP holder
+    if (!txVector.IsUlMu()) // the sender of a TB PPDU is not the TXOP holder
     {
-        VhtFrameExchangeManager::SetTxopHolder(psdu, txVector);
+        return VhtFrameExchangeManager::FindTxopHolder(hdr, txVector);
     }
+    return std::nullopt;
 }
 
 bool
@@ -2184,7 +2187,7 @@
         auto acknowledgment = static_cast<WifiUlMuMultiStaBa*>(m_txParams.m_acknowledgment.get());
         std::size_t index = acknowledgment->baType.m_bitmapLen.size();
 
-        if (m_txTimer.GetStasExpectedToRespond().count(sender) == 0)
+        if (!m_txTimer.GetStasExpectedToRespond().contains(sender))
         {
             NS_LOG_WARN("Received a TB PPDU from an unexpected station: " << sender);
             return;
@@ -2235,7 +2238,7 @@
         }
 
         // Schedule the transmission of a Multi-STA BlockAck frame if needed
-        if (!acknowledgment->stationsReceivingMultiStaBa.empty() && !m_multiStaBaEvent.IsRunning())
+        if (!acknowledgment->stationsReceivingMultiStaBa.empty() && !m_multiStaBaEvent.IsPending())
         {
             m_multiStaBaEvent = Simulator::Schedule(m_phy->GetSifs(),
                                                     &HeFrameExchangeManager::SendMultiStaBlockAck,
@@ -2253,7 +2256,7 @@
             m_txTimer.Cancel();
             m_channelAccessManager->NotifyAckTimeoutResetNow();
 
-            if (!m_multiStaBaEvent.IsRunning())
+            if (!m_multiStaBaEvent.IsPending())
             {
                 // all of the stations that replied with a TB PPDU sent QoS Null frames.
                 NS_LOG_DEBUG("Continue the TXOP");
@@ -2273,7 +2276,7 @@
     {
         const auto& sender = hdr.GetAddr2();
 
-        if (m_txTimer.GetStasExpectedToRespond().count(sender) == 0)
+        if (!m_txTimer.GetStasExpectedToRespond().contains(sender))
         {
             NS_LOG_WARN("Received a TB PPDU from an unexpected station: " << sender);
             return;
@@ -2404,7 +2407,7 @@
                                                                m_txParams.m_txVector);
 
             // remove the sender from the set of stations that are expected to send a BlockAck
-            if (m_txTimer.GetStasExpectedToRespond().count(sender) == 0)
+            if (!m_txTimer.GetStasExpectedToRespond().contains(sender))
             {
                 NS_LOG_WARN("Received a BlockAck from an unexpected stations: " << sender);
                 return;
@@ -2657,7 +2660,7 @@
         auto acknowledgment = static_cast<WifiUlMuMultiStaBa*>(m_txParams.m_acknowledgment.get());
         std::size_t index = acknowledgment->baType.m_bitmapLen.size();
 
-        if (m_txTimer.GetStasExpectedToRespond().count(sender) == 0)
+        if (!m_txTimer.GetStasExpectedToRespond().contains(sender))
         {
             NS_LOG_WARN("Received a TB PPDU from an unexpected station: " << sender);
             return;
@@ -2693,7 +2696,7 @@
         }
 
         // Schedule the transmission of a Multi-STA BlockAck frame if needed
-        if (!acknowledgment->stationsReceivingMultiStaBa.empty() && !m_multiStaBaEvent.IsRunning())
+        if (!acknowledgment->stationsReceivingMultiStaBa.empty() && !m_multiStaBaEvent.IsPending())
         {
             m_multiStaBaEvent = Simulator::Schedule(m_phy->GetSifs(),
                                                     &HeFrameExchangeManager::SendMultiStaBlockAck,
@@ -2711,7 +2714,7 @@
             m_txTimer.Cancel();
             m_channelAccessManager->NotifyAckTimeoutResetNow();
 
-            if (!m_multiStaBaEvent.IsRunning())
+            if (!m_multiStaBaEvent.IsPending())
             {
                 // all of the stations that replied with a TB PPDU sent QoS Null frames.
                 NS_LOG_DEBUG("Continue the TXOP");
@@ -2730,7 +2733,7 @@
     {
         Mac48Address sender = psdu->GetAddr2();
 
-        if (m_txTimer.GetStasExpectedToRespond().count(sender) == 0)
+        if (!m_txTimer.GetStasExpectedToRespond().contains(sender))
         {
             NS_LOG_WARN("Received a TB PPDU from an unexpected station: " << sender);
             return;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/he/he-frame-exchange-manager.h ns-3.42/src/wifi/model/he/he-frame-exchange-manager.h
--- ns-3.41/src/wifi/model/he/he-frame-exchange-manager.h	2024-02-09 14:44:08.585795000 -0800
+++ ns-3.42/src/wifi/model/he/he-frame-exchange-manager.h	2024-05-29 15:29:47.200073700 -0700
@@ -79,7 +79,8 @@
     void SetWifiMac(const Ptr<WifiMac> mac) override;
     void CalculateAcknowledgmentTime(WifiAcknowledgment* acknowledgment) const override;
     void CalculateProtectionTime(WifiProtection* protection) const override;
-    void SetTxopHolder(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector) override;
+    std::optional<Mac48Address> FindTxopHolder(const WifiMacHeader& hdr,
+                                               const WifiTxVector& txVector) override;
     bool VirtualCsMediumIdle() const override;
 
     /**
@@ -219,9 +220,9 @@
      * \param trigger the MU-RTS Trigger Frame header
      * \param muRtsSnr the SNR of the MU-RTS in linear scale
      */
-    void SendCtsAfterMuRts(const WifiMacHeader& muRtsHdr,
-                           const CtrlTriggerHeader& trigger,
-                           double muRtsSnr);
+    virtual void SendCtsAfterMuRts(const WifiMacHeader& muRtsHdr,
+                                   const CtrlTriggerHeader& trigger,
+                                   double muRtsSnr);
 
     /**
      * \return the mode used to transmit a CTS after an MU-RTS.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/he/he-operation.cc ns-3.42/src/wifi/model/he/he-operation.cc
--- ns-3.41/src/wifi/model/he/he-operation.cc	2024-02-09 14:44:08.585795000 -0800
+++ ns-3.42/src/wifi/model/he/he-operation.cc	2024-05-29 15:29:47.200073700 -0700
@@ -14,7 +14,8 @@
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
- * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ * Authors: Sébastien Deronne <sebastien.deronne@gmail.com>
+ *          Stefano Avallone <stavallo@unina.it>
  */
 
 #include "he-operation.h"
@@ -23,16 +24,8 @@
 {
 
 HeOperation::HeOperation()
-    : m_bssColor(0),
-      m_defaultPEDuration(0),
-      m_twtRequired(0),
-      m_heDurationBasedRtsThreshold(0),
-      m_partialBssColor(0),
-      m_maxBssidIndicator(0),
-      m_txBssidIndicator(0),
-      m_bssColorDisabled(0),
-      m_dualBeacon(0),
-      m_basicHeMcsAndNssSet(0xfffc)
+    : m_basicHeMcsAndNssSet(0xffff),
+      m_6GHzOpInfo(m_heOpParams.m_6GHzOpPresent)
 {
 }
 
@@ -49,45 +42,118 @@
 }
 
 void
-HeOperation::Print(std::ostream& os) const
+HeOperation::HeOperationParams::Print(std::ostream& os) const
 {
-    os << "HE Operation=" << GetHeOperationParameters() << "|" << GetBasicHeMcsAndNssSet();
+    os << "Default PE Duration: " << +m_defaultPeDuration << " TWT Required: " << +m_twtRequired
+       << " TXOP Duration RTS Threshold: " << m_txopDurRtsThresh
+       << " VHT Operation Information Present: " << +m_vhOpPresent
+       << " Co-Hosted BSS: " << +m_coHostedBss << " ER SU Disable: " << +m_erSuDisable
+       << " 6 GHz Operation Information Present: " << m_6GHzOpPresent;
 }
 
 uint16_t
-HeOperation::GetInformationFieldSize() const
+HeOperation::HeOperationParams::GetSerializedSize() const
+{
+    return 3;
+}
+
+void
+HeOperation::HeOperationParams::Serialize(Buffer::Iterator& start) const
+{
+    uint16_t twoBytes = m_defaultPeDuration | (m_twtRequired << 3) | (m_txopDurRtsThresh << 4) |
+                        (m_vhOpPresent << 14) | (m_coHostedBss << 15);
+    uint8_t oneByte = m_erSuDisable | ((m_6GHzOpPresent ? 1 : 0) << 1);
+    start.WriteHtolsbU16(twoBytes);
+    start.WriteU8(oneByte);
+}
+
+uint16_t
+HeOperation::HeOperationParams::Deserialize(Buffer::Iterator& start)
+{
+    Buffer::Iterator tmp = start;
+    uint16_t twoBytes = start.ReadLsbtohU16();
+    uint8_t oneByte = start.ReadU8();
+    m_defaultPeDuration = twoBytes & 0x07;
+    m_twtRequired = (twoBytes >> 3) & 0x01;
+    m_txopDurRtsThresh = (twoBytes >> 4) & 0x03ff;
+    m_vhOpPresent = (twoBytes >> 14) & 0x01;
+    m_coHostedBss = (twoBytes >> 15) & 0x01;
+    m_erSuDisable = oneByte & 0x01;
+    m_6GHzOpPresent = ((oneByte >> 1) & 0x01) == 1;
+    return start.GetDistanceFrom(tmp);
+}
+
+void
+HeOperation::BssColorInfo::Print(std::ostream& os) const
+{
+    os << "BSS Color: " << +m_bssColor << " Partial BSS Color: " << +m_partialBssColor
+       << " BSS Color Disabled: " << +m_bssColorDisabled;
+}
+
+uint16_t
+HeOperation::BssColorInfo::GetSerializedSize() const
+{
+    return 1;
+}
+
+void
+HeOperation::BssColorInfo::Serialize(Buffer::Iterator& start) const
+{
+    uint8_t oneByte = m_bssColor | (m_partialBssColor << 6) | (m_bssColorDisabled << 7);
+    start.WriteU8(oneByte);
+}
+
+uint16_t
+HeOperation::BssColorInfo::Deserialize(Buffer::Iterator& start)
+{
+    Buffer::Iterator tmp = start;
+    uint8_t oneByte = start.ReadU8();
+    m_bssColor = oneByte & 0x3f;
+    m_partialBssColor = (oneByte >> 6) & 0x01;
+    m_bssColorDisabled = (oneByte >> 7) & 0x01;
+    return start.GetDistanceFrom(tmp);
+}
+
+void
+HeOperation::OpInfo6GHz::Print(std::ostream& os) const
 {
-    return 7;
+    os << "Primary channel: " << +m_primCh << " Channel Width: " << +m_chWid
+       << " Duplicate Beacon: " << +m_dupBeacon << " Regulatory Info: " << +m_regInfo
+       << " Channel center frequency segment 0: " << +m_chCntrFreqSeg0
+       << " Channel center frequency segment 1: " << +m_chCntrFreqSeg1
+       << " Minimum Rate: " << +m_minRate;
+}
+
+uint16_t
+HeOperation::OpInfo6GHz::GetSerializedSize() const
+{
+    return 5;
 }
 
 void
-HeOperation::SetHeOperationParameters(uint32_t ctrl)
+HeOperation::OpInfo6GHz::Serialize(Buffer::Iterator& start) const
+{
+    start.WriteU8(m_primCh);
+    uint8_t control = m_chWid | (m_dupBeacon << 2) | (m_regInfo << 3);
+    start.WriteU8(control);
+    start.WriteU8(m_chCntrFreqSeg0);
+    start.WriteU8(m_chCntrFreqSeg1);
+    start.WriteU8(m_minRate);
+}
+
+uint16_t
+HeOperation::OpInfo6GHz::Deserialize(Buffer::Iterator& start)
 {
-    m_bssColor = ctrl & 0x3f;
-    m_defaultPEDuration = (ctrl >> 6) & 0x07;
-    m_twtRequired = (ctrl >> 9) & 0x01;
-    m_heDurationBasedRtsThreshold = (ctrl >> 10) & 0x03ff;
-    m_partialBssColor = (ctrl >> 20) & 0x01;
-    m_maxBssidIndicator = (ctrl >> 21) & 0xff;
-    m_txBssidIndicator = (ctrl >> 29) & 0x01;
-    m_bssColorDisabled = (ctrl >> 30) & 0x01;
-    m_dualBeacon = (ctrl >> 31) & 0x01;
-}
-
-uint32_t
-HeOperation::GetHeOperationParameters() const
-{
-    uint32_t val = 0;
-    val |= m_bssColor & 0x3f;
-    val |= (m_defaultPEDuration & 0x07) << 6;
-    val |= (m_twtRequired & 0x01) << 9;
-    val |= (m_heDurationBasedRtsThreshold & 0x03ff) << 10;
-    val |= (m_partialBssColor & 0x01) << 20;
-    val |= (m_maxBssidIndicator & 0xff) << 21;
-    val |= (m_txBssidIndicator & 0x01) << 29;
-    val |= (m_bssColorDisabled & 0x01) << 30;
-    val |= (m_dualBeacon & 0x01) << 31;
-    return val;
+    Buffer::Iterator i = start;
+    m_primCh = i.ReadU8();
+    uint8_t control = i.ReadU8();
+    m_chWid = control & 0x03;
+    m_dupBeacon = (control >> 2) & 0x01;
+    m_regInfo = (control >> 3) & 0x07;
+    m_chCntrFreqSeg0 = i.ReadU8();
+    m_chCntrFreqSeg1 = i.ReadU8();
+    m_minRate = i.ReadU8();
+    return i.GetDistanceFrom(start);
 }
 
 void
@@ -97,17 +163,17 @@
 
     // IEEE 802.11ax-2021 9.4.2.248.4 Supported HE-MCS And NSS Set field
     uint8_t val = 0x03; // not supported
-    if (maxHeMcs > 9)   // MCS 0 - 11
+    if (maxHeMcs == 11) // MCS 0 - 11
     {
         val = 0x02;
     }
-    else if (maxHeMcs > 7) // MCS 0 - 9
+    else if (maxHeMcs >= 9) // MCS 0 - 9
     {
         val = 0x01;
     }
-    else if (maxHeMcs == 7) // MCS 0 - 7
+    else // MCS 0 - 7
     {
-        val = 0x01;
+        val = 0x00;
     }
 
     // clear bits for that nss
@@ -118,32 +184,44 @@
     m_basicHeMcsAndNssSet |= ((val & 0x03) << ((nss - 1) * 2));
 }
 
-uint16_t
-HeOperation::GetBasicHeMcsAndNssSet() const
-{
-    return m_basicHeMcsAndNssSet;
-}
-
 void
-HeOperation::SetBssColor(uint8_t bssColor)
+HeOperation::Print(std::ostream& os) const
 {
-    NS_ABORT_UNLESS(bssColor < 64); // 6 bits
-    m_bssColor = bssColor;
-    m_bssColorDisabled = 0;
+    os << "HE Operation=[HE Operation Parameters|";
+    m_heOpParams.Print(os);
+    os << "][BSS Color|";
+    m_bssColorInfo.Print(os);
+    os << "][Basic HE-MCS And NSS Set: " << m_basicHeMcsAndNssSet << "]";
+    if (m_6GHzOpInfo)
+    {
+        os << "[6 GHz Operation Info|";
+        m_6GHzOpInfo->Print(os);
+        os << "]";
+    }
 }
 
-uint8_t
-HeOperation::GetBssColor() const
+uint16_t
+HeOperation::GetInformationFieldSize() const
 {
-    return m_bssColor;
+    uint16_t ret = 1 /* Element ID Ext */ + m_heOpParams.GetSerializedSize() +
+                   m_bssColorInfo.GetSerializedSize() + 2 /* Basic HE-MCS And NSS Set */;
+    if (m_6GHzOpInfo)
+    {
+        ret += m_6GHzOpInfo->GetSerializedSize();
+    }
+    return ret;
 }
 
 void
 HeOperation::SerializeInformationField(Buffer::Iterator start) const
 {
-    // write the corresponding value for each bit
-    start.WriteHtolsbU32(GetHeOperationParameters());
-    start.WriteU16(GetBasicHeMcsAndNssSet());
+    m_heOpParams.Serialize(start);
+    m_bssColorInfo.Serialize(start);
+    start.WriteHtolsbU16(m_basicHeMcsAndNssSet);
+    if (m_6GHzOpInfo)
+    {
+        m_6GHzOpInfo->Serialize(start);
+    }
     // todo: VHT Operation Information (variable)
 }
 
@@ -151,11 +229,18 @@
 HeOperation::DeserializeInformationField(Buffer::Iterator start, uint16_t length)
 {
     Buffer::Iterator i = start;
-    uint32_t heOperationParameters = i.ReadLsbtohU32();
-    m_basicHeMcsAndNssSet = i.ReadU16();
-    SetHeOperationParameters(heOperationParameters);
+    m_heOpParams.Deserialize(i);
+    m_bssColorInfo.Deserialize(i);
+    m_basicHeMcsAndNssSet = i.ReadLsbtohU16();
+    if (m_heOpParams.m_6GHzOpPresent)
+    {
+        OpInfo6GHz opInfo6GHz;
+        opInfo6GHz.Deserialize(i);
+        m_6GHzOpInfo = opInfo6GHz;
+    }
+
     // todo: VHT Operation Information (variable)
-    return length;
+    return i.GetDistanceFrom(start);
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/he/he-operation.h ns-3.42/src/wifi/model/he/he-operation.h
--- ns-3.41/src/wifi/model/he/he-operation.h	2024-02-09 14:44:08.585795000 -0800
+++ ns-3.42/src/wifi/model/he/he-operation.h	2024-05-29 15:29:47.200073700 -0700
@@ -14,13 +14,15 @@
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
- * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ * Authors: Sébastien Deronne <sebastien.deronne@gmail.com>
+ *          Stefano Avallone <stavallo@unina.it>
  */
 
 #ifndef HE_OPERATION_H
 #define HE_OPERATION_H
 
 #include "ns3/wifi-information-element.h"
+#include "ns3/wifi-opt-field.h"
 
 namespace ns3
 {
@@ -42,64 +44,140 @@
     WifiInformationElementId ElementIdExt() const override;
     void Print(std::ostream& os) const override;
 
-    /**
-     * Set the HE Operation Parameters field in the HE Operation information element.
-     *
-     * \param ctrl the HE Operation Parameters field in the HE Operation information element
-     */
-    void SetHeOperationParameters(uint32_t ctrl);
+    /// HE Operation Parameters field
+    struct HeOperationParams
+    {
+        uint8_t m_defaultPeDuration : 3 {0};  ///< Default PE Duration
+        uint8_t m_twtRequired : 1 {0};        ///< TWT Required
+        uint16_t m_txopDurRtsThresh : 10 {0}; ///< TXOP Duration RTS Threshold
+        uint8_t m_vhOpPresent : 1 {0}; ///< VHT Operation Information Present (value 1 unsupported)
+        uint8_t m_coHostedBss : 1 {0}; ///< Co-Hosted BSS (value 1 unsupported)
+        uint8_t m_erSuDisable : 1 {0}; ///< ER SU Disable
+        bool m_6GHzOpPresent{false};   ///< 6 GHz Operation Information Present (do not set, it is
+                                       ///< set by the OptFieldWithPresenceInd)
+
+        /**
+         * Print the content of the HE Operation Parameters field.
+         *
+         * \param os output stream
+         */
+        void Print(std::ostream& os) const;
+
+        /**
+         * \return the serialized size of the HE Operation Parameters field
+         */
+        uint16_t GetSerializedSize() const;
+
+        /**
+         * Serialize the HE Operation Parameters field
+         *
+         * \param start an iterator which points to where the information should be written
+         */
+        void Serialize(Buffer::Iterator& start) const;
+
+        /**
+         * Deserialize the HE Operation Parameters field.
+         *
+         * \param start an iterator which points to where the information should be read from
+         * \return the number of bytes read
+         */
+        uint16_t Deserialize(Buffer::Iterator& start);
+    };
+
+    /// BSS Color Information field
+    struct BssColorInfo
+    {
+        uint8_t m_bssColor : 6 {0};         ///< BSS Color
+        uint8_t m_partialBssColor : 1 {0};  ///< Partial BSS Color
+        uint8_t m_bssColorDisabled : 1 {0}; ///< BSS Color Disabled
+
+        /**
+         * Print the content of the BSS Color Information field.
+         *
+         * \param os output stream
+         */
+        void Print(std::ostream& os) const;
+
+        /**
+         * \return the serialized size of the BSS Color Information field
+         */
+        uint16_t GetSerializedSize() const;
+
+        /**
+         * Serialize the BSS Color Information field
+         *
+         * \param start an iterator which points to where the information should be written
+         */
+        void Serialize(Buffer::Iterator& start) const;
+
+        /**
+         * Deserialize the BSS Color Information field.
+         *
+         * \param start an iterator which points to where the information should be read from
+         * \return the number of bytes read
+         */
+        uint16_t Deserialize(Buffer::Iterator& start);
+    };
+
+    /// 6 GHz Operation Information field
+    struct OpInfo6GHz
+    {
+        uint8_t m_primCh{0};         ///< Primary Channel
+        uint8_t m_chWid : 2 {0};     ///< Channel Width
+        uint8_t m_dupBeacon : 1 {0}; ///< Duplicate Beacon
+        uint8_t m_regInfo : 3 {0};   ///< Regulatory Info
+        uint8_t : 2;                 ///< Reserved bits
+        uint8_t m_chCntrFreqSeg0{0}; ///< Channel center frequency segment 0
+        uint8_t m_chCntrFreqSeg1{0}; ///< Channel center frequency segment 1
+        uint8_t m_minRate{0};        ///< Minimum Rate
+
+        /**
+         * Print the content of the 6 GHz Operation Information field.
+         *
+         * \param os output stream
+         */
+        void Print(std::ostream& os) const;
+
+        /**
+         * \return the serialized size of the 6 GHz Operation Information field
+         */
+        uint16_t GetSerializedSize() const;
+
+        /**
+         * Serialize the 6 GHz Operation Information field
+         *
+         * \param start an iterator which points to where the information should be written
+         */
+        void Serialize(Buffer::Iterator& start) const;
+
+        /**
+         * Deserialize the 6 GHz Operation Information field.
+         *
+         * \param start an iterator which points to where the information should be read from
+         * \return the number of bytes read
+         */
+        uint16_t Deserialize(Buffer::Iterator& start);
+    };
+
     /**
      * Set the Basic HE-MCS and NSS field in the HE Operation information element
-     * by specifying the tuple (<i>nss</i>, <i>maxMcs</i>).
+     * by specifying the pair (<i>nss</i>, <i>maxMcs</i>).
      *
      * \param nss the NSS
      * \param maxHeMcs the maximum supported HE-MCS value corresponding to that NSS
      */
     void SetMaxHeMcsPerNss(uint8_t nss, uint8_t maxHeMcs);
 
-    /**
-     * Return the HE Operation Parameters field in the HE Operation information element.
-     *
-     * \return the HE Operation Parameters field in the HE Operation information element
-     */
-    uint32_t GetHeOperationParameters() const;
-    /**
-     * Return the Basic HE-MCS And Nss field in the HE Operation information element.
-     *
-     * \return the Basic HE-MCS And Nss field in the HE Operation information element
-     */
-    uint16_t GetBasicHeMcsAndNssSet() const;
-    /**
-     * Set the BSS color
-     * \param bssColor the BSS color value
-     */
-    void SetBssColor(uint8_t bssColor);
-    /**
-     * Get the BSS color
-     * \return the BSS color value
-     */
-    uint8_t GetBssColor() const;
+    // Fields
+    HeOperationParams m_heOpParams; //!< HE Operation Parameters field
+    BssColorInfo m_bssColorInfo;    //!< BSS Color Information field
+    uint16_t m_basicHeMcsAndNssSet; ///< Basic HE-MCS And NSS set (use setter to set value)
+    OptFieldWithPresenceInd<OpInfo6GHz> m_6GHzOpInfo; ///< 6 GHz Operation Information field
 
   private:
     uint16_t GetInformationFieldSize() const override;
     void SerializeInformationField(Buffer::Iterator start) const override;
     uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
-
-    // HE Operation Parameters fields
-    uint8_t m_bssColor;                     //!< BSS color
-    uint8_t m_defaultPEDuration;            //!< default PE duration
-    uint8_t m_twtRequired;                  //!< TWT required
-    uint16_t m_heDurationBasedRtsThreshold; //!< HE duration based RTS threshold
-    uint8_t m_partialBssColor;              //!< partial BSS color
-    uint8_t m_maxBssidIndicator;            //!< max BSSID indicator
-    uint8_t m_txBssidIndicator;             //!< TX BSSID indicator
-    uint8_t m_bssColorDisabled;             //!< BSS color disabled
-    uint8_t m_dualBeacon;                   //!< Dual Beacon
-
-    // Basic HE-MCS and NSS Set
-    uint16_t m_basicHeMcsAndNssSet; ///< basic HE MCS NSS set
-
-    // TODO: VHT Operation Information subfields not defined in the standard yet.
 };
 
 } // namespace ns3
